function y = decasteljau(b,t)
%
% the points b are assumed to be a matrix (d x (n+1)), where d = 1,2 or 3.
% 
n = size(b,2)-1;
y = reshape(repmat(b,length(t),1),size(b,1),length(t)*(n+1));
y = mat2cell(y,size(b,1),ones(1,size(b,2))*length(t));
t = t(:)';
t = repmat(t,size(b,1),1);
for r = 1:n
  for i = 1:n-r+1
    y{i} = (1-t).*y{i}+t.*y{i+1};
  end
end
% on output, y{i} = b_i^(n+1-i)    